# enews.sh
# by: Kurt Hoffmann (BubbaStinky@netscape.net)
# automatically creates news eBooks from a web site
######################################################

# for yes or no options (do not modify)
YES=1
NO=0

# date variables (do not modify)
DATE=`date +"%m-%d-%y"`
LONG_DATE=`date +"%m-%d-%y at %H:%M:%S"`

######################################################
#
# START MODIFYING HERE
#

# parsing the web site
WEB_SITE="http://www.slashdot.org"
SKIP_FIRST_LINES=58
OMIT_LINES_WITH="Read More..."
STOP_AT="Slashdot Login"

# generating eBook
TITLE="Slashdot Daily News for $DATE"
FILE_NAME="slashday"
EBOOK_DESC="Slashdot $DATE"
USE_CUSTOM_PICTURE=$YES
CUSTOM_PICTURE=slash.bin

# generate web page
GENERATE_WEB_PAGE=$NO
PAGE_NAME=slashdot.html
PAGE_HTML="<HTML><BODY><CENTER><H1>my daily eBook</H1><P>Files last updated $LONG_DATE<P><A HREF=$FILE_NAME.89y>$FILE_NAME 89</A><P><A HREF=$FILE_NAME.9xy>$FILE_NAME 92+</A></BODY></HTML>"

# ftp upload
FTP_UPLOAD=$NO
FTP_HOST=ftp.mywebsite.com
FTP_USERNAME=username
FTP_PASSWORD=password
FTP_DIRECTORY=/ebooks

# cleanup
DELETE_LOCAL_FILES=$NO

######################################################
#
# STOP STOP STOP STOP MODIFYING HERE
#

# get the raw web page
lynx -dump -nolist $WEB_SITE > web.txt

# add title
echo -e "$TITLE\n\n" > web2.txt

# cut top lines
LENGTH=`wc -l web.txt | cut -c1-8`
LENGTH=`expr $LENGTH - $SKIP_FIRST_LINES`
if [ `echo $LENGTH | cut -c0-1` = "-" ]
then
  LENGTH=0
fi
tail "-$LENGTH" web.txt >> web2.txt

# generate ebook text
if [ -e ebook.txt ]
then
  rm ebook.txt
fi

LENGTH=`expr $LENGTH + 3`
while [ "$LENGTH" -ne 0 ]
do
  # read web page line by line
  LINE=`tail -$LENGTH web2.txt | head -1`
  LENGTH=`expr $LENGTH - 1`

  # stop when we find certain text
  if [ `echo "$LINE" | grep "$STOP_AT" | wc -l | cut -c1-8` -eq 1 ]
  then
    LENGTH=0
  else
    # write line if it doesn't contain news-partition text
    if [ `echo "$LINE" | grep "$OMIT_LINES_WITH" | wc -l | cut -c1-8` -eq 0 ]
    then
      echo "$LINE" >> ebook.txt
    else
      echo -e "************************\n" >> ebook.txt
    fi
  fi
done



# generate eBook
export PATH=$PATH:.
if [ $USE_CUSTOM_PICTURE = $YES ]
then
  ./ttebkgen -t "$CUSTOM_PICTURE" ebook.txt "$FILE_NAME" "$EBOOK_DESC"
else
  ./ttebkgen ebook.txt "$FILE_NAME" "$EBOOK_DESC"
fi

# generate web page
if [ $GENERATE_WEB_PAGE = $YES ]
then
  echo $PAGE_HTML > $PAGE_NAME

  # ftp upload
  if [ $FTP_UPLOAD = $YES ]
  then
    ncftpput -u $FTP_USERNAME -p $FTP_PASSWORD $FTP_HOST $FTP_DIRECTORY $FILE_NAME.89y $FILE_NAME.9xy $PAGE_NAME
  fi

  if [ $DELETE_LOCAL_FILES = $YES ]
  then
    rm $PAGE_NAME
  fi
else

  # ftp upload
  if [ $FTP_UPLOAD = $YES ]
  then
    ncftpput -u $FTP_USERNAME -p $FTP_PASSWORD $FTP_HOST $FTP_DIRECTORY $FILE_NAME.89y $FILE_NAME.9xy
  fi

fi


# delete files
if [ $DELETE_LOCAL_FILES = $YES ]
then
  rm web.txt
  rm web2.txt
  rm ebook.txt
  rm $FILE_NAME.89y
  rm $FILE_NAME.9xy
fi
